//Funktion ladeDLL() kann als globale Funktion
//aufgerufen werden
//Port.dll muss im aktuellen Verzeichnis stehen
//Rckgabe = false - wenn DLL nicht geladen werden kann

#include <vcl.h>

HINSTANCE hdll;
typedef UINT(CALLBACK *open)(char *);
open opencom;
typedef UINT (CALLBACK *read)();
read readbyte;
typedef (CALLBACK *send)(UCHAR);
send sendbyte;
typedef (CALLBACK *close)();
close closecom;
typedef (CALLBACK *time_)(UINT);
time_ timeout;

//-----------------------------------------------------
bool ladeDLL (void) {
  hdll = LoadLibrary("Port.dll");
  if(hdll == NULL)
  {
      return false;
  }
  else
  {
      opencom = (open)GetProcAddress(hdll,"OPENCOM");
      readbyte = (read)GetProcAddress(hdll,"READBYTE");
      sendbyte = (send)GetProcAddress(hdll,"SENDBYTE");
      closecom = (close)GetProcAddress(hdll,"CLOSECOM");
      timeout = (time_)GetProcAddress(hdll,"TIMEOUT");
      return true;
  }
}
//------------------------------------------------------
/*
int opencom(char*)
   bergabe: z.B. "COM2: baud=9600 data=8 parity=N stop=1"
             oder "COM1:9600,N,8,1"
   Rckgabe: 0 bei Fehler

int readbyte()
   Rckgabe: -1 wenn Empfangspuffer leer ist
             sonst das empfangene Byte

void sendbyte(unsigned char)
   bergabe: zu sendendes Byte

void timeout(unsigned int)
   ist Zeit berschritten, wird readbyte abgebrochen und liefert -1

void closecom(void)
*/
